//+-----------------------------------------------------------------------+
//| NewsGrab.dll - Example-EA by Heiko Neuhaus (webmaster@euros4click.de) |
//+-----------------------------------------------------------------------+

bool opendemotrades = true;

// Start copying the code below this line, if you want to use my DLL with your favorite EA
//****************************************************************************************

int  magic = 12345; // <- This number must be changed to the MagicNumber of the EA you are using!
                    // Remember that the EA must have its own MagicNumber for each currency-pair you are using it with!

// Remember to copy NewsGrab.dll to your Metatrader-Folder!
#import "NewsGrab.dll"
   string AreNewsComing (string SymbolName, int ReportMinutesBefore, int ReportMinutesAfter, int MinimumImportance, int& MinutesInfo[]);

int start()
  {

   // Just some variables we store some data in...
   int OpenOrders = 0;
   int MinutesInfo[1];
   int typesave[100];
   double lotsave[100];
   double slsave[100];
   double tpsave[100];
   string commentsave[100];

   // Grab upcoming news info and store results in "MinutesInfo" and "news"-Variables.
   string news = AreNewsComing (Symbol(), 5, 5, 1, MinutesInfo);
   
   if (news == "error")
   {
      Comment ("Error reported from NewsGrab-DLL! You should fix this!");
   }
   else
   {
      // Negative MinutesInfo values mean that the news event lies in the past.
      bool panic = false;
      if (news == "none") {  Comment ("Upcoming news: None!"); }
      else if (MinutesInfo[0] >= 0) { Comment ("Upcoming news: ", news, " in ", MinutesInfo[0], " min."); panic = true; }
      else { Comment ("Passed news: ", news, " which was ", MinutesInfo[0], " min ago."); panic = true; }

      // Count orders from this EA-instance
      OpenOrders = 0;
      for (int i = 0; i < OrdersTotal(); i++)
      {
         OrderSelect (i, SELECT_BY_POS, MODE_TRADES);
         if (OrderMagicNumber() == magic) OpenOrders++;     
      }

      // News ahead! Close all trades that this Expert-Advisor has opened.
      if (panic == true)
      {
         // Walk through all opened trades
         i = 0;
         int cnt = 0;
         while (cnt < OrdersTotal())
         {
            OrderSelect (cnt, SELECT_BY_POS, MODE_TRADES);
            // This variable ("magic") needs very likely to be changed to the "MagicNumber" of the EA that you are using.
            if (OrderMagicNumber() == magic)
            {
               lotsave[i]     = OrderLots();
               slsave[i]      = OrderStopLoss();
               tpsave[i]      = OrderTakeProfit();
               typesave[i]    = OrderType();
               commentsave[i] = OrderComment();
               OrderClose (OrderTicket(), OrderLots(), OrderClosePrice(), 10, CLR_NONE);
               i++;
            }
            else
            {
               cnt ++;
            }
         }   
         panic = false;      
      }
      // Okay no more news. Re-Open trades!
      else if (lotsave[0] != 0)
      {
         for (i = 0; i < 100; i++)
         {
            if (lotsave[i] != 0)
            {
               OrderSend (Symbol(), typesave[i], lotsave[i], Ask, 10, slsave[i], tpsave[i], commentsave[i], magic, 0, Blue);
               typesave[i] = 0;
               lotsave[i] = 0;
               slsave[i] = 0;
               tpsave[i] = 0;
               commentsave[i] = '';
            }
         }
      }
   }

//********************************************************************************************************
// The code below this line just opens a few trades as demonstration of the DLLs capabilities. It does not
// need to be copied to other EAs.

   // Those Trades will be closed before a news-event and opened again afterwards.
   if ((opendemotrades == true) && (OpenOrders == 0))
   {
      OrderSend (Symbol(), OP_BUY, 0.1, Ask, 100, Ask - 100 * Point, Ask + 100 * Point, "Demotrade 1", magic, 0, Blue);
      OrderSend (Symbol(), OP_BUY, 0.2, Ask, 100, Ask - 200 * Point, Ask + 200 * Point, "Demotrade 2", magic, 0, Blue);
      OrderSend (Symbol(), OP_BUY, 0.3, Ask, 100, Ask - 300 * Point, Ask + 300 * Point, "Demotrade 2", magic, 0, Blue);
      opendemotrades = false;
      return (0);
   }

}